/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomMutationEvent_H__
#define __GdomMutationEvent_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomEvent.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomMutationEvent GdomMutationEvent;
typedef struct _GdomMutationEventClass GdomMutationEventClass;


#define GDOM_TYPE_MUTATION_EVENT            (gdom_mutation_event_get_type())
#define GDOM_MUTATION_EVENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_MUTATION_EVENT, GdomMutationEvent))
#define GDOM_MUTATION_EVENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_MUTATION_EVENT, GdomMutationEvent)Class)
#define GDOM_IS_MUTATION_EVENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_MUTATION_EVENT))
#define GDOM_IS_MUTATION_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_MUTATION_EVENT))
#define GDOM_MUTATION_EVENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_MUTATION_EVENT, GdomMutationEventClass))

typedef struct _GdomMutationEventPrivate GdomMutationEventPrivate;

struct _GdomMutationEvent {
    GdomEvent parent_instance;
    GdomMutationEventPrivate *priv;
};

struct _GdomMutationEventClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_mutation_event_get_type (void);

WEBKIT_API void
gdom_mutation_event_init_mutation_event (GdomMutationEvent *thiz, gchar * type, gboolean can_bubble, gboolean cancelable, GdomNode * related_node, gchar * prev_value, gchar * new_value, gchar * attr_name, gushort attr_change);

G_END_DECLS

#endif /* __GdomMutationEvent_H__ */
